<?php

@set_time_limit(0);

function CheckAbilityOfInstallation()
{
  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // check if all files are writeable
  $files = file($GLOBALS['TMP_FOLDER']."files.txt");

  // add check for module files
  global $db, $MODULE_FOLDER, $TMP_FOLDER;
  $installed_modules = $db->get_results("SELECT Keyword FROM Module", ARRAY_A);
  foreach ((array)$installed_modules as $module)
  {
    if (file_exists($MODULE_FOLDER.$module['Keyword']))
    {
       $module_files = nc_installer_filelist($TMP_FOLDER."modules/$module[Keyword]");
       foreach ((array)$module_files as $module_file) {
         $files[] = "/netcat/modules/$module[Keyword]/$module_file";
       }
     }

  }

  foreach ($files as $file)
  {
     $file = $GLOBALS['DOCUMENT_ROOT'].rtrim($file);
     if (file_exists($file))
     {
        if (!is_writable($file) && !@chmod($file, 0777)) // file is not writable
        {
           $result['ErrorMessage'] = "<b>         netcat.</b><br><small>($file   )</small>";
           $result['Success'] = 0;
        }
     }
     else // check dir
     {
        $dirname = dirname($file);
        // find the nearest existing parent directory
        while (!file_exists($dirname))
        {
           $dirname = preg_replace("!/[^/]+$!", "", $dirname);
           if ($dirname=="$GLOBALS[DOCUMENT_ROOT]/netcat") break;
        }

        if (!is_writable($dirname) && !@chmod($dirname, 0777)) // directory is not writable
        {
           $result['ErrorMessage'] = "<b>      $GLOBALS[DOCUMENT_ROOT]/netcat   .</b><br><small>($dirname   )</small>";
           $result['Success'] = 0;
        }
     }
  }

  return $result;
}

function InstallPatch() {
global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db;
	
	$TMP_FOLDER = str_replace("//", "/", $TMP_FOLDER);

	$result['Success'] = 1;
	$result['ErrorMessage'] = '!';

	# SystemID
	$SystemID = $db->get_var("SELECT SystemID FROM Settings");
	
	# update modules
	$installed_modules = $db->get_col("SELECT Keyword FROM Module WHERE Keyword IN ('auth','banner','forum','linkmanager','netshop','search','stats')");
  
	# Calendar
	$installed_modules[] = "calendar";

	# Blog
	switch ($SystemID) { 
		case 3: # Extra
		case 4: # Plus
		case 6: # E-Commerce
		case 8: # Corporate
			$installed_modules[] = "blog";
		break;
	}
	
	# TagsCloud
	switch ($SystemID) { 
		case 3: # Extra
		case 4: # Plus
		case 8: # Corporate
			$installed_modules[] = "tagscloud";
		break;
	}
	
	foreach($installed_modules AS $keyword) {

	    # Execute SQL, if any
	    if( file_exists($TMP_FOLDER."modules/".$keyword.".sql") ) {
			ExecSQL($TMP_FOLDER."modules/".$keyword.".sql");
	    }

		# Create DIR if not exist
		if( !file_exists($MODULE_FOLDER.$keyword) ) @mkdir($MODULE_FOLDER.$keyword, 0755);
	    
		# Copy all files to modules folder
		nc_installer_copy_all($TMP_FOLDER."modules/".$keyword, $MODULE_FOLDER.$keyword);

	    # include script if necessary
	    if( file_exists($TMP_FOLDER."modules/".$keyword.".inc.php") ) {
			include($TMP_FOLDER."modules/".$keyword.".inc.php");
	    }

	    # Remove old files
	    if( file_exists($TMP_FOLDER."modules/".$keyword.".remove") ) {

			$files_to_remove = file($TMP_FOLDER."modules/".$keyword.".remove");

		    foreach($files_to_remove AS $file) {
		        $file = trim($file, "\r\n/");
		        if( @is_dir($ROOT_FOLDER.$file) ) {
					@rmdir($ROOT_FOLDER.$file);
				}
		        else {
					@unlink($ROOT_FOLDER.$file);
				}
		    }

		}
	}

return $result;
}

function nc_installer_copy_all($from, $to) {

    $from = str_replace("//", "/", $from);
    $to = str_replace("//", "/", $to);
	
    $dh = opendir($from);
    if(!$dh) return false;

    while( ( $file = readdir($dh) )!==false ) {
		
		if($file=="." || $file=="..") continue;
		
		if( @is_dir($from."/".$file) ) {
			@mkdir($to."/".$file, 0755);
			nc_installer_copy_all($from."/".$file, $to."/".$file);
		}
		else {
			copy($from."/".$file, $to."/".$file);
		}
		
    }

    closedir($dh);
	
return true;
}


function nc_installer_filelist($dir) {
    static $level;
    static $start_dir;

    $dir = str_replace("//", "/", $dir);
    if (!$level) $start_dir = $dir;

    $ret = array();
    $dh = @opendir($dir); // non-existent dir may be passed

    if (!$dh) return $ret;
    $level++;

    while (false !== ($file = readdir($dh))) {
      if ($file=="." || $file=="..") continue;
      if (is_dir("$dir/$file")) {
        $ret = array_merge($ret, nc_installer_filelist("$dir/$file"));
      }
      else {
        $ret[] = preg_replace("!^$start_dir/!", "", "$dir/$file");
      }
    }

    closedir($dh);
    $level--;
    return $ret;
}

# ---     
$t_Abl_of_Install = CheckAbilityOfInstallation();
if($t_Abl_of_Install['Success']) {

	# ---  
	if( $db->get_var("SHOW COLUMNS FROM `Settings` LIKE 'PlugsInstallType'") )
		$db->query("ALTER TABLE `Settings` DROP `PlugsInstallType`");
	if( $db->get_var("SHOW COLUMNS FROM `Settings` LIKE 'MySQLPath'") )
		$db->query("ALTER TABLE `Settings` DROP `MySQLPath`");
	if( $db->get_var("SHOW COLUMNS FROM `Settings` LIKE 'WinRARPath'") )
		$db->query("ALTER TABLE `Settings` DROP `WinRARPath`");
	if( $db->get_var("SHOW COLUMNS FROM `Settings` LIKE 'FileManagerSub'") )
		$db->query("ALTER TABLE `Settings` DROP `FileManagerSub`");
	# -------------------------------------------
	# ---  
	if( !$db->get_var("SHOW COLUMNS FROM `Class` LIKE 'CustomSettingsTemplate'") )
		$db->query("ALTER TABLE `Class` ADD `CustomSettingsTemplate` TEXT;");
	if( !$db->get_var("SHOW COLUMNS FROM `Class` LIKE 'ClassDescription'") )
		$db->query("ALTER TABLE `Class` ADD `ClassDescription` TEXT;");
	if( !$db->get_var("SHOW COLUMNS FROM `Template` LIKE 'CustomSettings'") )
		$db->query("ALTER TABLE `Template` ADD `CustomSettings` TEXT AFTER `Settings`;");
	if( !$db->get_var("SHOW COLUMNS FROM `Sub_Class` LIKE 'CustomSettings'") )
		$db->query("ALTER TABLE `Sub_Class` ADD `CustomSettings` TEXT;");
	if( !$db->get_var("SHOW COLUMNS FROM `Subdivision` LIKE 'TemplateSettings'") )
		$db->query("ALTER TABLE `Subdivision` ADD `TemplateSettings` TEXT AFTER `Favorite`;");
	if( !$db->get_var("SHOW COLUMNS FROM `Catalogue` LIKE 'TemplateSettings'") )
		$db->query("ALTER TABLE `Catalogue` ADD `TemplateSettings` TEXT AFTER `Template_ID`;");
	if( !$db->get_var("SHOW COLUMNS FROM `Settings` LIKE 'EditDesignTemplateID'") )
		$db->query("ALTER TABLE `Settings` ADD `EditDesignTemplateID` INT DEFAULT '0' AFTER `ProductNumber`;");
	if( !$db->get_var("SHOW COLUMNS FROM `Subdivision` LIKE 'UseEditDesignTemplate'") )
		$db->query("ALTER TABLE `Subdivision` ADD `UseEditDesignTemplate` tinyint(1) NOT NULL default '0'");
	# -------------------------------------------
	# --- template   
	$template_file = fopen($GLOBALS['TMP_FOLDER']."template.txt", "r");
	$sql = fread($template_file, filesize($GLOBALS['TMP_FOLDER']."template.txt") );
	fclose($template_file);
	#
	if($sql) {
		$db->query($sql);
		$EditDesignTemplateID = $db->insert_id;
		if($EditDesignTemplateID) $db->query("UPDATE Settings SET `EditDesignTemplateID`=".$EditDesignTemplateID."");
	}
	# -------------------------------------------
	unset($t_Abl_of_Install);
	
}
# -------------------------------------------
?>